unit Oldaapi;

{

                       Data Translation API


         C header file translated by Lorin Milescu, 05-28-2001


}


interface


uses


Windows,

OLTypes,
OLDADefs,
OLMem;


const


oldaapi32   = 'oldaapi32.dll';


(*
#include <oltypes.h>
#include <oldadefs.h>
#include <olerrors.h>
#include <olmem.h>

#ifdef __cplusplus
extern "C" {
#endif

// Data Acquisition SubSystem

*)


type


HDASS    = THandle;
PHDASS   = ^HDASS;
LPHDASS  = PHDASS;


HSSLIST  = THandle;


HDEV     = THANDLE;
PHDEV    = ^HDEV;
LPHDEV   = PHDEV;

// conversion macros for measure frequency

//#define LongToFreq(l)    *(float*) &(l)
//#define FreqToLong(f)    *(long*) &(f)

(*
#define OLDA_SAMPLE_SIZE_IN_BYTES 2

typedef struct DASSInfotag {
   HDEV   hdev;
   OLSS   Olss;
   UINT   uiElement;
} DASSINFO, *PDASSINFO;

#define LPDASSINFO PDASSINFO

#ifdef STRICT
typedef BOOL (CALLBACK* DASSPROC)(PTSTR pszName, OLSS OlSs,
                               UINT uiElement, LPARAM lParam) :ECODE; stdcall; external oldaapi32;
#else
typedef FARPROC DASSPROC;
#endif

#ifdef STRICT
typedef BOOL (CALLBACK* CAPSPROC)(UINT uiEnumCap, DBL dParam1,
                                 DBL dParam2, LPARAM lParam) :ECODE; stdcall; external oldaapi32;
#else
typedef FARPROC CAPSPROC;
#endif

*)

type


DABRDPROC = function(pszBrdName, pszEntry :PChar; lParam :LPARAM) :BOOL; stdcall;

(*

#ifdef STRICT
typedef BOOL (CALLBACK *DABRDPROCEX) (PTSTR pszBrdName, PTSTR pszDriverName, HKEY hKeyDriver, LPARAM lParam) :ECODE; stdcall; external oldaapi32;
#else
typedef FARPROC DABRDPROCEX;
#endif


#ifdef STRICT
typedef BOOL (CALLBACK *SSLISTPROC) (HSSLIST hSSList, hDass :HDASS; LPARAM lParam) :ECODE; stdcall; external oldaapi32;
#else
typedef FARPROC SSLISTPROC;
#endif


// parameters for olDaEnumSSCaps
#define OL_ENUM_FILTERS       100
#define OL_ENUM_RANGES        101
#define OL_ENUM_GAINS         102
#define OL_ENUM_RESOLUTIONS   103



// simultaneous start stuff
typedef struct SSDASStag
{ 
   UINT        uiSizeSSDASS;
   VOID        *pSelf;
   HDASS       hDass;
   VOID        *pNext;
}
SSDASS;

typedef SSDASS *PSSDASS;

typedef struct SSLISTtag
{ 
   UINT      uiSizeSSLIST;
   UINT      uiCount;
   HSSLIST   hSelf;
   PSSDASS   pFirst;
   PSSDASS   pLast;
}
SSLIST;

typedef SSLIST *PSSLIST;

#define SSlFromHandle(h) (PSSLIST)(h)
#define HandleFromSSl(p) (HSSLIST)(p)
*)

// macros for error checking Simultaneous Start stuff
{

#define IsBadHSSLIST(h) ( (IsBadReadPtr((SSLIST *)(h), sizeof (SSLIST))) ||\
                         ((h) == (HSSLIST) 0) ||\
                         (((SSLIST *)(h))->hSelf != (h)) )

#define IsBadHDASS(h) ( (IsBadReadPtr((DEVICE_DATA *)(h), sizeof (DEVICE_DATA))) ||\
                        ((h) == (HDASS) 0) ||\
                        (((DEVICE_DATA *)(h))->pSelf != (h)) )

}


// function prototypes

function olDaInitialize(pszName :PChar; var hDev :HDEV) :ECODE; stdcall; external oldaapi32;
function olDaTerminate(hDev :HDEV) :ECODE; stdcall; external oldaapi32;

{
function olDaGetVersion(PTSTR pszVersion,UINT uiMaxChars) :ECODE; stdcall; external oldaapi32;
function olDaGetDriverVersion(HDEV hDev, PTSTR pszVersion, UINT uiMaxChars) :ECODE; stdcall; external oldaapi32;
function olDaGetWndHandle (hDass :HDASS; HWND* phWnd) :ECODE; stdcall; external oldaapi32;
}

function olDaPutBuffer(hDass :HDASS; hBuf :HBUF) :ECODE; stdcall; external oldaapi32;
function olDaGetBuffer(hDass :HDASS; var hBuf :HBUF) :ECODE; stdcall; external oldaapi32;

{
function olDaGetDeviceName (HDEV hDev, PTSTR lpszName, UINT uiMaxChars) :ECODE; stdcall; external oldaapi32;
}

function olDaEnumBoards(pfnDaBrdProc :DABRDPROC; lParam :LPARAM) :ECODE; stdcall; external oldaapi32;

{
function olDaEnumBoardsEx (DABRDPROCEX pfnDaBrdProcEx, LPARAM lParam) :ECODE; stdcall; external oldaapi32;
function olDaEnumSubSystems (HDEV hDev, DASSPROC pfnDaProc, LPARAM lParam) :ECODE; stdcall; external oldaapi32;
}

function olDaGetDASS(hDev :HDEV; OlSs :OLSS; uiElement :UINT; var hDass :HDASS) :ECODE; stdcall; external oldaapi32;
function olDaReleaseDASS(hDass :HDASS) :ECODE; stdcall; external oldaapi32;

{
function olDaGetDASSInfo(hDass :HDASS; PDASSINFO pDassInfo) :ECODE; stdcall; external oldaapi32;
}

function olDaGetDevCaps (hDev :HDEV; OlDc :OLDC; var uiCap :UINT) :ECODE; stdcall; external oldaapi32;
function olDaGetSSCaps(hDass :HDASS; OlSSc :OLSSC; var Cap :UINT) :ECODE; stdcall; external oldaapi32;
function olDaGetSSCapsEx(hDass :HDASS; OlSSc :OLSSC; var Cap :DBL) :ECODE; stdcall; external oldaapi32;

{
function olDaEnumSSCaps (hDass :HDASS; UINT uiEnumCap, CAPSPROC pfnCapsProc, LPARAM lParam) :ECODE; stdcall; external oldaapi32;
}

function olDaSetDmaUsage (hDass :HDASS; uiUse :UINT) :ECODE; stdcall; external oldaapi32;

{
function olDaGetDmaUsage (hDass :HDASS; PUINT puiUse) :ECODE; stdcall; external oldaapi32;
function olDaSetTriggeredScanUsage (hDass :HDASS; BOOL fUse) :ECODE; stdcall; external oldaapi32;
function olDaGetTriggeredScanUsage (hDass :HDASS; PBOOL pfUse) :ECODE; stdcall; external oldaapi32;
function olDaSetChannelType (hDass :HDASS; UINT uiType) :ECODE; stdcall; external oldaapi32;
function olDaGetChannelType (hDass :HDASS; PUINT puiType) :ECODE; stdcall; external oldaapi32;
}

function olDaSetChannelListSize (hDass :HDASS; uiSize :UINT) :ECODE; stdcall; external oldaapi32;

{
function olDaGetChannelListSize (hDass :HDASS; PUINT puiSize) :ECODE; stdcall; external oldaapi32;
}

function olDaSetChannelListEntry (hDass :HDASS; uiEntry, uiChan :UINT) :ECODE; stdcall; external oldaapi32;

{
function olDaGetChannelListEntry (hDass :HDASS; UINT uiEntry, PUINT puiChan) :ECODE; stdcall; external oldaapi32;
}

function olDaSetGainListEntry (hDass :HDASS; uiEntry :UINT; dGain :DBL) :ECODE; stdcall; external oldaapi32;

{
function olDaGetGainListEntry (hDass :HDASS; UINT uiEntry, PDBL pdGain) :ECODE; stdcall; external oldaapi32;
function olDaSetChannelFilter (hDass :HDASS; UINT uiChan, DBL dCutOffFreq) :ECODE; stdcall; external oldaapi32;
function olDaGetChannelFilter (hDass :HDASS; UINT uiChan, PDBL pdCutOffFreq) :ECODE; stdcall; external oldaapi32;
function olDaSetEncoding (hDass :HDASS; UINT uiEnc) :ECODE; stdcall; external oldaapi32;
function olDaGetEncoding (hDass :HDASS; PUINT puiEnc) :ECODE; stdcall; external oldaapi32;
function olDaSetTrigger (hDass :HDASS; UINT uiTrig) :ECODE; stdcall; external oldaapi32;
function olDaGetTrigger (hDass :HDASS; PUINT puiTrig) :ECODE; stdcall; external oldaapi32;
function olDaSetResolution (hDass :HDASS; UINT uiBits) :ECODE; stdcall; external oldaapi32;
function olDaGetResolution (hDass :HDASS; PUINT puiBits) :ECODE; stdcall; external oldaapi32;
function olDaSetRange (hDass :HDASS; DBL dMaxVoltage, DBL dMinVoltage) :ECODE; stdcall; external oldaapi32;
function olDaGetRange (hDass :HDASS; PDBL pdMaxVoltage, PDBL pdMinVoltage) :ECODE; stdcall; external oldaapi32;
function olDaSetClockSource (hDass :HDASS; UINT uiClk) :ECODE; stdcall; external oldaapi32;
function olDaGetClockSource (hDass :HDASS; PUINT puiClk) :ECODE; stdcall; external oldaapi32;
}



function olDaSetClockFrequency(hDass :HDASS; dfFreq :DBL) :ECODE; stdcall; external oldaapi32;


{
function olDaGetClockFrequency (hDass :HDASS; PDBL pdfFreq) :ECODE; stdcall; external oldaapi32;
function olDaSetRetriggerFrequency (hDass :HDASS; DBL dfFreq) :ECODE; stdcall; external oldaapi32;
function olDaGetRetriggerFrequency (hDass :HDASS; PDBL pdfFreq) :ECODE; stdcall; external oldaapi32;
function olDaSetExternalClockDivider(hDass :HDASS; ULNG ulDivider) :ECODE; stdcall; external oldaapi32;
function olDaGetExternalClockDivider(hDass :HDASS; PULNG pulDivider) :ECODE; stdcall; external oldaapi32;
function olDaSetGateType (hDass :HDASS; UINT uiGate) :ECODE; stdcall; external oldaapi32;
function olDaGetGateType (hDass :HDASS; PUINT puiGate) :ECODE; stdcall; external oldaapi32;
function olDaSetPulseType (hDass :HDASS; UINT uiPulse) :ECODE; stdcall; external oldaapi32;
function olDaGetPulseType (hDass :HDASS; PUINT puiPulse) :ECODE; stdcall; external oldaapi32;
function olDaSetPulseWidth (hDass :HDASS; DBL dfPulseWidthPercent) :ECODE; stdcall; external oldaapi32;
function olDaGetPulseWidth (hDass :HDASS; PDBL pdfPulseWidthPercent) :ECODE; stdcall; external oldaapi32;
function olDaSetCTMode (hDass :HDASS; UINT uiCTMode) :ECODE; stdcall; external oldaapi32;
function olDaGetCTMode (hDass :HDASS; PUINT puiCTMode) :ECODE; stdcall; external oldaapi32;
function olDaSetCascadeMode (hDass :HDASS; UINT uiCascadeMode) :ECODE; stdcall; external oldaapi32;
function olDaGetCascadeMode (hDass :HDASS; PUINT puiCascadeMode) :ECODE; stdcall; external oldaapi32;
function olDaReadEvents (hDass :HDASS; PULNG pulEvents) :ECODE; stdcall; external oldaapi32;
}

function olDaConfig(hDass :HDASS) :ECODE; stdcall; external oldaapi32;
function olDaStart(hDass :HDASS) :ECODE; stdcall; external oldaapi32;

{
function olDaStop (HDASS hDass) :ECODE; stdcall; external oldaapi32;
function olDaContinue (HDASS hDass) :ECODE; stdcall; external oldaapi32;
function olDaReset (HDASS hDass) :ECODE; stdcall; external oldaapi32;
}

function olDaFlushBuffers(hDass :HDASS) :ECODE; stdcall; external oldaapi32;

{
LPSTR WINAPI olDaGetErrorString (ECODE eCode, PTSTR pStr, UINT uiMaxSize) :ECODE; stdcall; external oldaapi32;
function olDaSetWndHandle (hDass :HDASS; HWND hWnd, LPARAM lParam) :ECODE; stdcall; external oldaapi32;
}

function olDaPutSingleValue(hDass :HDASS; lValue :LNG; uiChannel :UINT; dGain :DBL) :ECODE; stdcall; external oldaapi32;
function olDaGetSingleValue(hDass :HDASS; plValue :PLNG; uiChannel :UINT; dGain :DBL) :ECODE; stdcall; external oldaapi32;

{
function olDaGetDataFlow(hDass :HDASS; PUINT puiDataFlow) :ECODE; stdcall; external oldaapi32;
}


function olDaSetDataFlow(hDass :HDASS; uiDataFlow :UINT) :ECODE; stdcall; external oldaapi32;


{
function olDaGetWrapMode (hDass :HDASS; PUINT puiWrapMode) :ECODE; stdcall; external oldaapi32;
}

function olDaSetWrapMode(hDass :HDASS; uiWrapMode :UINT) :ECODE; stdcall; external oldaapi32;

{
function olDaPause (HDASS hDass) :ECODE; stdcall; external oldaapi32;
function olDaAbort (HDASS hDass) :ECODE; stdcall; external oldaapi32;
function olDaMeasureFrequency (hDass :HDASS; HWND  hWnd, DBL dfCount_Duration) :ECODE; stdcall; external oldaapi32;
function olDaGetQueueSize (hDass :HDASS; UINT uiQueue, PUINT puiSize) :ECODE; stdcall; external oldaapi32;
function olDaDTConnectBurst (hDass :HDASS; UINT uiTransferSize, UINT uiTransferCount) :ECODE; stdcall; external oldaapi32;
function olDaSetChannelListEntryInhibit (hDass :HDASS; UINT uiEntry, BOOL fInhibit) :ECODE; stdcall; external oldaapi32;
function olDaGetChannelListEntryInhibit (hDass :HDASS; UINT uiEntry, PBOOL pfInhibit) :ECODE; stdcall; external oldaapi32;
function olDaSetDigitalIOListEntry (hDass :HDASS; UINT uiEntry, UINT uiValue) :ECODE; stdcall; external oldaapi32;
function olDaGetDigitalIOListEntry (hDass :HDASS; UINT uiEntry, PUINT puiValue) :ECODE; stdcall; external oldaapi32;
function olDaSetSynchronousDigitalIOUsage (hDass :HDASS; BOOL fUse) :ECODE; stdcall; external oldaapi32;
function olDaGetSynchronousDigitalIOUsage (hDass :HDASS; PBOOL pfUse) :ECODE; stdcall; external oldaapi32;
}
function olDaGetSSList(var hSSList :HSSLIST) :ECODE; stdcall; external oldaapi32;
function olDaReleaseSSList (hSSList :HSSLIST) :ECODE; stdcall; external oldaapi32;
function olDaPutDassToSSList (hSSList :HSSLIST; hDass :HDASS) :ECODE; stdcall; external oldaapi32;
function olDaSimultaneousPrestart (hSSList :HSSLIST) :ECODE; stdcall; external oldaapi32;
function olDaSimultaneousStart (hSSList :HSSLIST) :ECODE; stdcall; external oldaapi32;
{
function olDaEnumSSList (HSSLIST hSSList, SSLISTPROC pfnSSListProc, LPARAM lParam) :ECODE; stdcall; external oldaapi32;
function olDaFlushFromBufferInprocess (hDass :HDASS; HBUF hBuf, ULNG ulNumSamples) :ECODE; stdcall; external oldaapi32;
}

function olDaSetNotificationProcedure (hDass :HDASS; pfnNotifyProc :OLNOTIFYPROC; lParam :LPARAM) :ECODE; stdcall; external oldaapi32;

{
function olDaGetNotificationProcedure (hDass :HDASS; OLNOTIFYPROC* pfnNotifyProc) :ECODE; stdcall; external oldaapi32;
function olDaSetDTConnectTransferSize (hDass :HDASS; UINT uiTransferSize) :ECODE; stdcall; external oldaapi32;
function olDaGetDTConnectTransferSize (hDass :HDASS; PUINT puiTransferSize) :ECODE; stdcall; external oldaapi32;
function olDaSetDTConnectTransferCount (hDass :HDASS; UINT uiTransferCount) :ECODE; stdcall; external oldaapi32;
function olDaGetDTConnectTransferCount (hDass :HDASS; PUINT puiTransferCount) :ECODE; stdcall; external oldaapi32;
function olDaSetChannelRange (hDass :HDASS; UINT uiChan, DBL dMaxVoltage, DBL dMinVoltage) :ECODE; stdcall; external oldaapi32;
function olDaGetChannelRange (hDass :HDASS; UINT uiChan, PDBL pdMaxVoltage, PDBL pdMinVoltage) :ECODE; stdcall; external oldaapi32;
function olDaSetRetriggerMode (hDass :HDASS; UINT uiRetriggerMode) :ECODE; stdcall; external oldaapi32;
function olDaGetRetriggerMode (hDass :HDASS; LPUINT lpuiRetriggerMode) :ECODE; stdcall; external oldaapi32;

function olDaGetSystemMetrics(hDass :HDASS;LPDWORD lpUserLatency,LPDWORD lpKernelLatency) :ECODE; stdcall; external oldaapi32;
function olDaEnableSystemMetrics(hDass :HDASS; BOOLEAN bEnable, BOOLEAN bClear) :ECODE; stdcall; external oldaapi32;
function olDaEnableHighResolutionTiming(BOOLEAN bEnable) :ECODE; stdcall; external oldaapi32;

function olDaSetPretriggerSource (hDass :HDASS; UINT uiTrig) :ECODE; stdcall; external oldaapi32;
function olDaGetPretriggerSource (hDass :HDASS; PUINT puiTrig) :ECODE; stdcall; external oldaapi32;
function olDaSetMultiscanCount (hDass :HDASS; UINT uiCount) :ECODE; stdcall; external oldaapi32;
function olDaGetMultiscanCount (hDass :HDASS; PUINT puiCount) :ECODE; stdcall; external oldaapi32;

function olDaSetRetrigger (hDass :HDASS; UINT uiTrig) :ECODE; stdcall; external oldaapi32;
function olDaGetRetrigger (hDass :HDASS; PUINT puiTrig) :ECODE; stdcall; external oldaapi32;   

function olDaGetSingleValueEx( hDass :HDASS; UINT uiChannel, BOOL bAutoRange, PDBL pdfGain, PLNG plValueCounts, PDBL pdfValueVolts ) :ECODE; stdcall; external oldaapi32;


// Utilitarian functions..taking no device or subsysten handle
//

function olDaCodeToVolts( DBL  dfMinRangeVolts,
                              DBL  dfMaxRangeVolts,
                              DBL  dfGain,
                              UINT uiBitsResolution,
                              UINT uiEncoding,
                              LNG  lCode,
                              PDBL pdfVoltage ) :ECODE; stdcall; external oldaapi32;

function olDaVoltsToCode( DBL  dfMinRangeVolts,
                              DBL  dfMaxRangeVolts,
                              DBL  dfGain,
                              UINT uiBitsResolution,
                              UINT uiEncoding,
                              DBL  dfVoltage, 
                              PLNG plCode ) :ECODE; stdcall; external oldaapi32;


// Undocumented corner
//

function olDiagWriteReg( HDEV hDev, ULNG Offset, ULNG Data, UINT Size ) :ECODE; stdcall; external oldaapi32;
function olDiagReadReg( HDEV hDev, ULNG Offset, PULNG pData, UINT Size ) :ECODE; stdcall; external oldaapi32;

function olDaSetHardwareInfo( HDEV hDev, 
                                  USHORT VendorId, 
                                  USHORT DeviceId, 
                                  USHORT ProductId, 
                                  ULNG SerialNumber,
                                  ULNG Reserved,
                                  PDRIVER_SPECIFIC_INFO pDriverSpecificInfo ) :ECODE; stdcall; external oldaapi32;

function olDaGetHardwareInfo( HDEV  hDev, 
                                  DTBUS_TYPE* BusType, 
                                  PUSHORT VendorId,
                                  PUSHORT DeviceId,
                                  PUSHORT  ProductId,
                                  PULNG SerialNumber,
                                  PULNG Reserved,
                                  PDRIVER_SPECIFIC_INFO pDriverSpecificInfo ) :ECODE; stdcall; external oldaapi32;

function olDaSetDriverSpecificInfo( HDEV hDev,
                                        PVOID pData,
                                        ULONG Length ) :ECODE; stdcall; external oldaapi32;

function olDaGetDriverSpecificInfo( HDEV hDev,
                                        PVOID pData,
                                        ULONG BuffSize ) :ECODE; stdcall; external oldaapi32;


function olDaModifyOpenLayersBoardName( PTSTR pszOldName, PTSTR pszNewName ) :ECODE; stdcall; external oldaapi32;
}

implementation


end.

